'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

var _lang = require('./lang');

var _lang2 = _interopRequireDefault(_lang);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * Convert a collection to a query string
 * @param {Object|Map|Array} query
 * @return {String}
 */
var stringify = function stringify(query) {
  var entries = Array.isArray(query) ? query : _lang2.default.entries(query);

  var pair = function pair(entry) {
    var enc = encodeURIComponent;

    var _entry = _slicedToArray(entry, 2);

    var k = _entry[0];
    var v = _entry[1];

    return enc(k) + '=' + enc(v);
  };

  return entries.map(pair).join('&');
};

var parse = {};

parse.entries = function (qs) {
  // strip leading question mark
  if (qs && qs[0] === '?') {
    qs = qs.slice(1);
  }

  if (!qs.length) {
    return [];
  }

  var decode = function decode(qs) {
    return decodeURIComponent(qs).replace(/\+/g, ' ');
  };

  var reducer = function reducer(out, pair) {
    out.push(pair.split('=').slice(0, 2).map(decode));
    return out;
  };

  return qs.split('&').reduce(reducer, []);
};

parse.map = function (qs) {
  return new Map(parse.entries(qs));
};

parse.object = function (qs) {
  var reducer = function reducer(out, entry) {
    var _entry2 = _slicedToArray(entry, 2);

    var k = _entry2[0];
    var v = _entry2[1];

    out[k] = v;
    return out;
  };

  return _lang2.default.reduce(parse.entries(qs), reducer, {});
};

exports.default = {
  stringify: stringify,
  parse: parse
};
module.exports = exports['default'];