'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _components = require('./components');

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Tree = function (_Component) {
  _inherits(Tree, _Component);

  _createClass(Tree, [{
    key: 'defaults',


    /**
     * Return configuration defaults
     * @param void
     * @return {Object}
     */
    value: function defaults() {
      return {
        tree: {},
        cache: new Map(),
        tokenize: function tokenize(expr) {
          return expr.split('/');
        }
      };
    }

    /**
     * @param {Object} options
     * @param {Object} options.tree - tree data
     * @param {Object} options.cache - object that implements get(), set() and has()
     * @param {Function} options.tokenize - path expresssion tokenizer
     */

  }]);

  function Tree() {
    var options = arguments.length <= 0 || arguments[0] === undefined ? {} : arguments[0];

    _classCallCheck(this, Tree);

    var _this = _possibleConstructorReturn(this, (Tree.__proto__ || Object.getPrototypeOf(Tree)).call(this, options));

    _this.tree = _this.option('tree', { pull: true });
    return _this;
  }

  /**
   * Tokenize the given expression on '.' and traverse the translation tree
   * until a match is found. If no match is found, return an empty string.
   * This is the main
   * @param {String} expr
   * @return {mixed}
   */


  _createClass(Tree, [{
    key: 'path',
    value: function path(expr) {
      var _options = this.options;
      var cache = _options.cache;
      var tokenize = _options.tokenize;


      if (cache.has(expr)) {
        return cache.get(expr);
      }

      var traverse = function traverse(tree, token) {
        if (tree && tree.hasOwnProperty(token)) {
          return tree[token];
        }
        throw new Error('failed to resolve path expression "' + expr + '"');
      };

      var value = tokenize(expr).reduce(traverse, this.tree);

      cache.set(expr, value);

      return value;
    }
  }]);

  return Tree;
}(_components.Component);

exports.default = { Tree: Tree };
module.exports = exports['default'];